'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('../../../styles/ReactiveLayout.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactiveLayout = function (_React$Component) {
  _inherits(ReactiveLayout, _React$Component);

  function ReactiveLayout(props) {
    _classCallCheck(this, ReactiveLayout);

    var _this = _possibleConstructorReturn(this, (ReactiveLayout.__proto__ || Object.getPrototypeOf(ReactiveLayout)).call(this, props));

    _this.toggleSidebar = function () {
      _this.setState(function (prevState, props) {
        if (prevState.open) {
          return { tx: -_this.state.sidebarWidth, open: false };
        } else {
          return { tx: 0, open: true };
        }
      });
    };

    _this.processTouchStart = function (e) {
      if (_this.touch) {} else {
        _this.touch = {
          start: new Date().getTime(),
          x0: e.touches[0].clientX,
          y0: e.touches[0].clientY
        };
      }
    };

    _this.processTouchMove = function (e) {
      if (!_this.touch) {
        return;
      }
      var now = new Date().getTime();
      var elapsed = now - _this.touch.start;
      var dx = e.touches[0].clientX - _this.touch.x0;
      var dy = e.touches[0].clientY - _this.touch.y0;
      var vx = dx / elapsed;
      var vy = dy / elapsed;
      if (_this.touch.pan) {
        var _dx = e.touches[0].clientX - _this.touch.x0;

        if (_this.touch.lx) {
          _this.touch.vx = (e.touches[0].clientX - _this.touch.lx) / (now - _this.touch.lt);
        }
        _this.touch.lt = now;
        _this.touch.lx = e.touches[0].clientX;

        var boundedX = Math.max(-_this.state.sidebarWidth, Math.min(0, _this.touch.sx + _dx));

        _this.setState(function (prevState, props) {
          return {
            sidebarReady: true,
            tx: boundedX,
            lx: _dx,
            panning: true
          };
        });
        // we have decided this is a pan
      } else {
        if (Math.abs(vx) > 0.1 && Math.abs(vy) < 0.25) {
          // this is a panning gesture
          _this.touch.sx = _this.state.tx;
          _this.touch.pan = true;
        }
      }
    };

    _this.processTouchEnd = function (e) {
      if (_this.touch.pan) {
        if (_this.touch.vx > 0) {
          _this.setState(function (prevState, props) {
            return { tx: 0, panning: false, open: true };
          });
        } else {
          _this.setState(function (prevState, props) {
            return {
              tx: -_this.state.sidebarWidth,
              panning: false,
              open: false
            };
          });
        }
      }
      delete _this.touch;
    };

    _this.state = { open: false, tx: 0, headerHeight: 54, sidebarReady: false };
    return _this;
  }

  _createClass(ReactiveLayout, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var headerHeight = (0, _jquery2.default)('nav.navbar').height();
      var sidebarWidth = (0, _jquery2.default)('#sidebarContainer').width();
      this.setState(function (nextState, props) {
        return {
          headerHeight: headerHeight,
          sidebarWidth: sidebarWidth,
          tx: -sidebarWidth,
          sidebarReady: true
        };
      });
    }
  }, {
    key: 'renderSidebar',
    value: function renderSidebar() {
      var sidebarStyle = {
        transitionDuration: this.state.panning ? '0s' : '0.25s',
        visibility: this.state.sidebarReady ? 'visible' : 'hidden',
        left: this.state.tx,
        width: 'auto'
      };
      return _react2.default.createElement(
        'div',
        { id: 'sidebarContainer', style: sidebarStyle, className: 'RLSidebarContainer' },
        this.props.Sidebar ? this.props.Sidebar : null
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        {
          onTouchEnd: this.processTouchEnd,
          onTouchStart: this.processTouchStart,
          onTouchMove: this.processTouchMove,
          className: 'RLContainer' },
        _react2.default.createElement(
          'div',
          { id: 'headerContainer', className: 'RLHeaderContainer' },
          this.props.Header
        ),
        _react2.default.createElement(
          'div',
          { className: 'RLPageContainer' },
          this.renderSidebar(),
          _react2.default.createElement(
            'div',
            { className: 'RLContentContainer' },
            this.props.Content
          )
        )
      );
    }
  }]);

  return ReactiveLayout;
}(_react2.default.Component);

exports.default = ReactiveLayout;


ReactiveLayout.propTypes = {
  Header: _propTypes2.default.element,
  Sidebar: _propTypes2.default.element,
  Content: _propTypes2.default.element
};