'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SYSTEM_CHECK_CLIENT_TIME = undefined;
exports.checkClientTime = checkClientTime;
exports.default = Reducer;
exports.rootSaga = rootSaga;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _immutable = require('immutable');

var _reduxSaga = require('redux-saga');

var _effects = require('redux-saga/effects');

var _reselect = require('reselect');

var _PackageInformation = require('../../PackageInformation');

var _PackageInformation2 = _interopRequireDefault(_PackageInformation);

var _request = require('../../utils/request');

var _request2 = _interopRequireDefault(_request);

var _reactNotificationSystemRedux = require('react-notification-system-redux');

var _reactNotificationSystemRedux2 = _interopRequireDefault(_reactNotificationSystemRedux);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = /*#__PURE__*/regeneratorRuntime.mark(checkClientTimeSaga),
    _marked2 = /*#__PURE__*/regeneratorRuntime.mark(watchCheckClientTime),
    _marked3 = /*#__PURE__*/regeneratorRuntime.mark(rootSaga); // ------------------------------------
// Imports
// ------------------------------------


// ------------------------------------
// Constants
// ------------------------------------
var SYSTEM_CHECK_CLIENT_TIME = exports.SYSTEM_CHECK_CLIENT_TIME = '@@SYSTEM/CHECK CLIENT TIME';

// ------------------------------------
// Actions
// ------------------------------------
function checkClientTime() {
  return {
    type: SYSTEM_CHECK_CLIENT_TIME
  };
}

// ------------------------------------
// Action Handlers
// ------------------------------------
var ACTION_HANDLERS = {};

// ------------------------------------
// Reducer
// ------------------------------------
var initialState = {};

function Reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _immutable.fromJS)(initialState);
  var action = arguments[1];

  var handler = ACTION_HANDLERS[action.type];

  return handler ? handler(state, action) : state;
}

// ------------------------------------
// Sagas
// ------------------------------------
function checkClientTimeSaga(action) {
  var hubUrl, t, response;
  return regeneratorRuntime.wrap(function checkClientTimeSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          hubUrl = window.__HUB_URL__;

          if (hubUrl) {
            _context.next = 4;
            break;
          }

          _context.next = 13;
          break;

        case 4:
          t = new Date();
          _context.next = 7;
          return (0, _effects.call)(_request2.default, window.__HUB_URL__ + '/api/timeCheck?t=' + t);

        case 7:
          response = _context.sent;

          if (!(response.success === true)) {
            _context.next = 11;
            break;
          }

          _context.next = 13;
          break;

        case 11:
          _context.next = 13;
          return (0, _effects.put)(_reactNotificationSystemRedux2.default.error({
            title: _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement('i', { className: 'fa fa-exclamation-triangle' }),
              ' System Time Warning'
            ),
            message: response.reason,
            autoDismiss: 5,
            position: 'tr'
          }));

        case 13:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked, this);
}

function watchCheckClientTime() {
  return regeneratorRuntime.wrap(function watchCheckClientTime$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return (0, _reduxSaga.takeLatest)(SYSTEM_CHECK_CLIENT_TIME, checkClientTimeSaga);

        case 2:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked2, this);
}

function rootSaga() {
  return regeneratorRuntime.wrap(function rootSaga$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.next = 2;
          return (0, _effects.fork)(watchCheckClientTime);

        case 2:
        case 'end':
          return _context3.stop();
      }
    }
  }, _marked3, this);
}