'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IMS_SERVER_INITIAL_STATE = undefined;
exports.serverInitialState = serverInitialState;
exports.default = Reducer;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } // ------------------------------------
// Imports
// ------------------------------------


// ------------------------------------
// Constants
// ------------------------------------
var IMS_SERVER_INITIAL_STATE = exports.IMS_SERVER_INITIAL_STATE = '@@IMS/SERVER_INITIAL_STATE';

// ------------------------------------
// Actions
// ------------------------------------
function serverInitialState(initialState) {
  return {
    type: IMS_SERVER_INITIAL_STATE,
    initialState: initialState
  };
}

// ------------------------------------
// Action Handlers
// ------------------------------------
var ACTION_HANDLERS = _defineProperty({}, IMS_SERVER_INITIAL_STATE, function (state, action) {
  if (_lodash2.default.isObjectLike(action.initialState)) {
    return state.mergeDeep((0, _immutable.fromJS)(action.initialState));
  } else {
    return state;
  }
});
// ------------------------------------
// Reducer
// ------------------------------------
var initialState = {};
function Reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _immutable.fromJS)(initialState);
  var action = arguments[1];

  var handler = ACTION_HANDLERS[action.type];

  return handler ? handler(state, action) : state;
}