'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.injectReducer = exports.makeRootReducer = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reactRouterRedux = require('react-router-redux');

var _reactNotificationSystemRedux = require('react-notification-system-redux');

var _combineReducers = require('./combineReducers');

var _combineReducers2 = _interopRequireDefault(_combineReducers);

var _security = require('../modules/security');

var _security2 = _interopRequireDefault(_security);

var _universal = require('../modules/universal');

var _universal2 = _interopRequireDefault(_universal);

var _packages = require('../modules/packages');

var _packages2 = _interopRequireDefault(_packages);

var _tooltips = require('../modules/tooltips');

var _tooltips2 = _interopRequireDefault(_tooltips);

var _system = require('../modules/system');

var _system2 = _interopRequireDefault(_system);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _globalReducers = void 0;

var makeRootReducer = exports.makeRootReducer = function makeRootReducer() {
  var globalReducers = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var asyncReducers = arguments[1];

  _globalReducers = globalReducers || {};
  return (0, _combineReducers2.default)(_extends({
    routing: _reactRouterRedux.routerReducer,
    security: _security2.default,
    tooltips: _tooltips2.default,
    system: _system2.default,
    notifications: _reactNotificationSystemRedux.reducer,
    __USER__PACKAGES: _packages2.default
  }, globalReducers, asyncReducers), _universal2.default);
};

var injectReducer = exports.injectReducer = function injectReducer(store, _ref) {
  var key = _ref.key,
      reducer = _ref.reducer;

  store.asyncReducers[key] = reducer;
  store.replaceReducer(makeRootReducer(_globalReducers, store.asyncReducers));
};

exports.default = makeRootReducer;