'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initializeSagas = exports.injectSaga = exports.sagaMiddleware = undefined;

var _reduxSaga = require('redux-saga');

var _reduxSaga2 = _interopRequireDefault(_reduxSaga);

var _security = require('../modules/security');

var _tooltips = require('../modules/tooltips');

var _system = require('../modules/system');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sagaRegistry = {};

var sagaMiddleware = exports.sagaMiddleware = (0, _reduxSaga2.default)();

var injectSaga = exports.injectSaga = function injectSaga(key, saga) {
  if (sagaRegistry[key]) {
    sagaRegistry[key].cancel();
  }
  sagaRegistry[key] = sagaMiddleware.run(saga);
};

var initializeSagas = exports.initializeSagas = function initializeSagas() {
  var sagas = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  injectSaga('security', _security.rootSaga);
  injectSaga('tooltips', _tooltips.rootSaga);
  injectSaga('system', _system.rootSaga);

  Object.keys(sagas).forEach(function (key) {
    injectSaga(key, sagas[key]);
  });
};