'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AppComponent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _Notifications = require('./Notifications');

var _Notifications2 = _interopRequireDefault(_Notifications);

var _reactRedux = require('react-redux');

var _tooltips = require('../../app/modules/tooltips');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AppComponent = exports.AppComponent = function (_Component) {
  _inherits(AppComponent, _Component);

  function AppComponent() {
    _classCallCheck(this, AppComponent);

    return _possibleConstructorReturn(this, (AppComponent.__proto__ || Object.getPrototypeOf(AppComponent)).apply(this, arguments));
  }

  _createClass(AppComponent, [{
    key: 'UNSAFE_componentWillMount',
    value: function UNSAFE_componentWillMount() {
      var _this2 = this;

      if (this.props.onAppWillMount) {
        this.props.onAppWillMount(this.props.store);
      }
      this.props.store.dispatch((0, _tooltips.fetchTooltips)());
      // Refresh tooltips every 5 minutes
      this.tooltipsRefreshInterval = setInterval(function () {
        _this2.props.store.dispatch((0, _tooltips.fetchTooltips)());
      }, 5 * 60 * 1000);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.tooltipsRefreshInterval) {
        clearInterval(this.tooltipsRefreshInterval);
        this.tooltipsRefreshInterval = undefined;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          history = _props.history,
          routes = _props.routes,
          store = _props.store;


      return _react2.default.createElement(
        _reactRedux.Provider,
        { store: store },
        _react2.default.createElement(
          'div',
          { style: { height: '100%' } },
          _react2.default.createElement(_Notifications2.default, null),
          _react2.default.createElement(_reactRouter.Router, { history: history, children: routes })
        )
      );
    }
  }]);

  return AppComponent;
}(_react.Component);

AppComponent.propTypes = {
  history: _propTypes2.default.object.isRequired,
  onAppWillMount: _propTypes2.default.func,
  routes: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.arrayOf(_propTypes2.default.object)]).isRequired,
  store: _propTypes2.default.object.isRequired
};
exports.default = AppComponent;