'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AreaPicker = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _gatewayReactTree = require('gateway-react-tree');

var ReactTree = _interopRequireWildcard(_gatewayReactTree);

var _ErrorAlert = require('../ErrorAlert');

var _ErrorAlert2 = _interopRequireDefault(_ErrorAlert);

var _LoadingIndicator = require('../LoadingIndicator');

var _LoadingIndicator2 = _interopRequireDefault(_LoadingIndicator);

var _request = require('../../utils/request');

var _request2 = _interopRequireDefault(_request);

var _cookies = require('../../utils/cookies');

require('../../styles/AreaPicker.css');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AreaPicker = exports.AreaPicker = function (_React$Component) {
  _inherits(AreaPicker, _React$Component);

  function AreaPicker(props) {
    _classCallCheck(this, AreaPicker);

    var _this = _possibleConstructorReturn(this, (AreaPicker.__proto__ || Object.getPrototypeOf(AreaPicker)).call(this, props));

    _this.state = {
      isLoading: true,
      show: false,
      treeData: []
    };
    return _this;
  }

  _createClass(AreaPicker, [{
    key: '_disableSelect',
    value: function _disableSelect() {
      return !(this.state.selectedNode && this.state.selectedNode.nodeId > 0);
    }
  }, {
    key: '_onEntering',
    value: function _onEntering() {
      this.setState({
        isLoading: true,
        treeData: []
      });
      return this._loadAreaTreeData();
    }
  }, {
    key: '_loadAreaTreeData',
    value: function _loadAreaTreeData() {
      var that = this;
      var requestOptions = {
        method: 'POST',
        body: JSON.stringify({
          nodeDetailTypes: [1]
        })
      };

      return (0, _request2.default)((0, _cookies.getHubUrl)() + '/api/trees/areas', requestOptions).then(function (result) {
        if (result && result.success === true) {
          if (Array.isArray(result.structure)) {
            for (var i = 0; i < result.structure.length; i++) {
              result.structure[i].open = true;
            }
          }

          that.setState({
            isLoading: false,
            treeData: result.structure
          });
        } else {
          that.setState({
            isLoading: false
          });
        }
        return null;
      }).catch(function (error) {
        that.setState({
          isLoading: false,
          error: error.message
        });
      });
    }
  }, {
    key: '_onHide',
    value: function _onHide() {
      this.setState({ show: false });
    }
  }, {
    key: '_onSelect',
    value: function _onSelect() {
      if (typeof this.props.onSelect === 'function') {
        var selectedNode = Object.assign({}, this.state.selectedNode, {
          children: undefined
        });
        this.props.onSelect(selectedNode);
      }
      this.setState({ show: false });
    }
  }, {
    key: '_showPicker',
    value: function _showPicker() {
      this.setState({ show: true });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var btnClasses = (0, _classnames2.default)('btn btn-info', {
        'btn-sm': this.props.size === 'sm',
        'btn-lg': this.props.size === 'lg',
        'btn-xs': this.props.size === 'xs'
      });

      return _react2.default.createElement(
        'button',
        _extends({}, this.props.buttonProps, { className: btnClasses, onClick: function onClick() {
            return _this2._showPicker();
          } }),
        _react2.default.createElement('i', { className: 'fa fa-sitemap' }),
        ' Choose Area',
        this.renderModal()
      );
    }
  }, {
    key: 'renderModal',
    value: function renderModal() {
      var _this3 = this;

      return _react2.default.createElement(
        _reactstrap.Modal,
        {
          isOpen: this.state.show,
          onEnter: function onEnter() {
            return _this3._onEntering();
          },
          onExit: function onExit() {
            return _this3._onHide();
          },
          'aria-labelledby': 'areaPickerTitle' },
        _react2.default.createElement(
          _reactstrap.ModalHeader,
          { toggle: this._onHide },
          _react2.default.createElement(
            'div',
            { id: 'areaPickerTitle' },
            'Select Area'
          )
        ),
        _react2.default.createElement(
          _reactstrap.ModalBody,
          null,
          _react2.default.createElement(_ErrorAlert2.default, { message: this.state.error }),
          _react2.default.createElement(
            'div',
            { className: 'panel panel-default' },
            _react2.default.createElement(
              'div',
              { className: 'panel-heading ims-area-picker__tree-header-container' },
              _react2.default.createElement('input', {
                className: 'form-control',
                placeholder: 'Search...',
                ref: 'filter',
                onChange: function onChange(e) {
                  _this3.refs.activeTree.setFilter(e.target.value);
                },
                type: 'text'
              })
            ),
            _react2.default.createElement(
              'div',
              { className: 'ims-area-picker__tree-container panel-body' },
              this.renderModalBody()
            )
          )
        ),
        _react2.default.createElement(
          _reactstrap.ModalFooter,
          null,
          _react2.default.createElement(
            'a',
            { className: 'btn btn-link', onClick: this._onHide },
            _react2.default.createElement('i', { className: 'fa fa-times', 'aria-hidden': 'true' }),
            ' Cancel'
          ),
          _react2.default.createElement(
            'button',
            {
              type: 'button',
              className: 'btn btn-primary',
              onClick: function onClick() {
                return _this3._onSelect();
              },
              disabled: this._disableSelect() },
            _react2.default.createElement('i', { className: 'fa fa-link', 'aria-hidden': 'true' }),
            ' Select'
          )
        )
      );
    }
  }, {
    key: 'renderModalBody',
    value: function renderModalBody() {
      var _this4 = this;

      if (this.state.isLoading) {
        return _react2.default.createElement(_LoadingIndicator2.default, null);
      }

      return _react2.default.createElement(ReactTree.Tree, {
        nodes: this.state.treeData,
        ref: 'activeTree',
        renderNodeTitle: this._renderNodeTitle,
        renderNodeToggle: this._renderNodeToggle,
        titlePropertyPath: 'name',
        onToggleClick: function onToggleClick(n) {
          return _this4._onNodeToggle(n);
        },
        onNodeClick: function onNodeClick(n) {
          return _this4._onNodeSelect(n);
        }
      });
    }
  }, {
    key: 'renderTreeHeader',
    value: function renderTreeHeader() {
      return _react2.default.createElement('div', { className: 'ims-area-picker__tree-header-container' });
    }
  }, {
    key: '_renderNodeTitle',
    value: function _renderNodeTitle(node) {
      var icon = node.nodeDetailTypeId === 1 ? 'fa fa-fw fa-folder-o' : null;
      return _react2.default.createElement(
        'div',
        { className: 'react-tree-node-title' },
        icon ? _react2.default.createElement('i', { className: icon }) : null,
        ' ',
        node.name
      );
    }
  }, {
    key: '_renderNodeToggle',
    value: function _renderNodeToggle(node, clickHandler) {
      var toggleClasses = (0, _classnames2.default)('fa', {
        'fa-caret-right': !node.open,
        'fa-caret-down': node.open
      });
      return _react2.default.createElement(
        'button',
        { className: 'btn btn-link btn-xs react-tree-node-toggle', onClick: clickHandler },
        _react2.default.createElement('i', { className: toggleClasses })
      );
    }
  }, {
    key: '_onNodeToggle',
    value: function _onNodeToggle(node) {
      this._onNodeSelect(node);
    }
  }, {
    key: '_onNodeSelect',
    value: function _onNodeSelect(node) {
      node.open = !node.open;
      this.setState({
        treeData: this.state.treeData
      });
      if (this.state.selectedNode) {
        this.state.selectedNode.active = false;
      }
      node.active = true;
      this.setState({
        selectedNode: node
      });
    }
  }]);

  return AreaPicker;
}(_react2.default.Component);

AreaPicker.propTypes = Object.assign({}, _react2.default.Component.propTypes, {
  buttonProps: _propTypes2.default.object,
  onSelect: _propTypes2.default.func,
  size: _propTypes2.default.oneOf(['sm', 'md', 'lg', 'xs'])
});

exports.default = AreaPicker;