'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DeleteLink = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DeleteLink = exports.DeleteLink = function (_React$Component) {
  _inherits(DeleteLink, _React$Component);

  function DeleteLink(props) {
    _classCallCheck(this, DeleteLink);

    var _this = _possibleConstructorReturn(this, (DeleteLink.__proto__ || Object.getPrototypeOf(DeleteLink)).call(this, props));

    _this.state = { show: false };
    return _this;
  }

  _createClass(DeleteLink, [{
    key: '_onConfirmDelete',
    value: function _onConfirmDelete() {
      this.props.onDelete();
      this.setState({ show: false });
    }
  }, {
    key: '_onHide',
    value: function _onHide() {
      this.setState({ show: false });
    }
  }, {
    key: '_showPrompt',
    value: function _showPrompt() {
      this.setState({ show: true });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var btnClasses = (0, _classnames2.default)('btn', this.props.useDefaultStyling ? 'btn-link' : '', this.props.className, {
        'btn-sm': this.props.size === 'sm',
        'btn-lg': this.props.size === 'lg',
        'btn-xs': this.props.size === 'xs'
      });

      var deleteDescription = this.props.deleteDescription ? '"' + this.props.deleteDescription + '"' : 'this item';
      var spanClass = this.props.useDefaultStyling ? 'text-danger' : '';
      return _react2.default.createElement(
        'button',
        { id: this.props.id, className: btnClasses, onClick: function onClick() {
            return _this2._showPrompt();
          } },
        _react2.default.createElement(
          'span',
          { className: spanClass },
          this.props.children
        ),
        _react2.default.createElement(
          _reactstrap.Modal,
          {
            isOpen: this.state.show,
            toggle: function toggle() {
              return _this2._onHide();
            },
            'aria-labelledby': 'confirmDeleteTitle' },
          _react2.default.createElement(
            _reactstrap.ModalHeader,
            null,
            'Confirm Delete'
          ),
          _react2.default.createElement(
            _reactstrap.ModalBody,
            null,
            'Are you sure you want to delete ',
            deleteDescription,
            '?'
          ),
          _react2.default.createElement(
            _reactstrap.ModalFooter,
            null,
            _react2.default.createElement(
              'button',
              {
                role: 'button',
                className: 'btn btn-link text-default',
                onClick: function onClick() {
                  _this2._onHide();
                } },
              _react2.default.createElement('i', { className: 'fa fa-times', 'aria-hidden': 'true' }),
              ' Cancel'
            ),
            _react2.default.createElement(
              'button',
              {
                type: 'button',
                className: 'btn btn-danger',
                onClick: function onClick() {
                  return _this2._onConfirmDelete();
                } },
              _react2.default.createElement('i', { className: 'fa fa-trash', 'aria-hidden': 'true' }),
              ' Delete'
            )
          )
        )
      );
    }
  }]);

  return DeleteLink;
}(_react2.default.Component);

DeleteLink.propTypes = Object.assign({}, _react2.default.Component.propTypes, {
  deleteDescription: _propTypes2.default.string,
  useDefaultStyling: _propTypes2.default.bool,
  onDelete: _propTypes2.default.func.isRequired
});

DeleteLink.defaultProps = {
  useDefaultStyling: true
};

exports.default = DeleteLink;