'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EquipmentAutosuggest = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAutosuggest = require('react-autosuggest');

var _reactAutosuggest2 = _interopRequireDefault(_reactAutosuggest);

var _request = require('../../utils/request');

var _request2 = _interopRequireDefault(_request);

var _cookies = require('../../utils/cookies');

var _EquipmentAutosuggestItem = require('./EquipmentAutosuggestItem');

var _EquipmentAutosuggestItem2 = _interopRequireDefault(_EquipmentAutosuggestItem);

require('../../styles/Autosuggest.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EquipmentAutosuggest = exports.EquipmentAutosuggest = function (_React$Component) {
  _inherits(EquipmentAutosuggest, _React$Component);

  function EquipmentAutosuggest(props) {
    _classCallCheck(this, EquipmentAutosuggest);

    var _this = _possibleConstructorReturn(this, (EquipmentAutosuggest.__proto__ || Object.getPrototypeOf(EquipmentAutosuggest)).call(this, props));

    _this.state = {
      value: '',
      equipment: [],
      isLoading: false
    };
    _this.lastRequestId = null;
    return _this;
  }

  _createClass(EquipmentAutosuggest, [{
    key: '_getSuggestionValue',
    value: function _getSuggestionValue(suggestion) {
      return suggestion.name;
    }
  }, {
    key: '_renderSuggestion',
    value: function _renderSuggestion(suggestion) {
      return _react2.default.createElement(_EquipmentAutosuggestItem2.default, { equipment: suggestion });
    }
  }, {
    key: '_loadEquipment',
    value: function _loadEquipment(search) {
      var _this2 = this;

      // Cancel the previous request
      if (this.lastRequestId !== null) {
        clearTimeout(this.lastRequestId);
      }

      this.setState({
        isLoading: true
      });

      var requestOptions = {
        method: 'POST',
        body: JSON.stringify({
          filter: search
        })
      };

      this.lastRequestId = setTimeout(function () {
        (0, _request2.default)((0, _cookies.getHubUrl)() + '/api/equipment/search', requestOptions).then(function (result) {
          if (result && result.success === true) {
            if (result.total === 0) {
              // No matching user accounts
              _this2.setState({
                isLoading: false,
                equipment: []
              });
            } else {
              _this2.setState({
                isLoading: false,
                equipment: result.equipment
              });
            }
          } else {
            // Error result from query
            _this2.setState({
              isLoading: false,
              error: 'User search returned an error: ' + result.message,
              equipment: null
            });
          }
        }).catch(function (error) {
          // Request error
          _this2.setState({
            isLoading: false,
            error: 'User search failed: ' + error.message,
            equipment: null
          });
        });
      }, 250);
    }
  }, {
    key: '_onChange',
    value: function _onChange(event, _ref) {
      var newValue = _ref.newValue;

      this.setState({
        value: newValue
      });
    }
  }, {
    key: '_onUserChange',
    value: function _onUserChange(value) {
      this.setState({ filter: value });
    }
  }, {
    key: '_onSuggestionsClearRequested',
    value: function _onSuggestionsClearRequested() {
      this.setState({
        equipment: []
      });
    }
  }, {
    key: '_onSuggestionsFetchRequested',
    value: function _onSuggestionsFetchRequested(_ref2) {
      var value = _ref2.value;

      this._loadEquipment(value);
    }
  }, {
    key: '_onSuggestionSelected',
    value: function _onSuggestionSelected(event, _ref3) {
      var suggestion = _ref3.suggestion;

      this.props.onSelect(suggestion);
      this.setState({
        value: ''
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state = this.state,
          value = _state.value,
          equipment = _state.equipment;

      var inputProps = {
        className: 'form-control',
        placeholder: 'To add equipment start typing its name...',
        value: value,
        onChange: function onChange(e, d) {
          return _this3._onChange(e, d);
        }
      };

      return _react2.default.createElement(_reactAutosuggest2.default, {
        id: this.props.autosuggestId,
        suggestions: equipment,
        onSuggestionsFetchRequested: function onSuggestionsFetchRequested(e) {
          return _this3._onSuggestionsFetchRequested(e);
        },
        onSuggestionsClearRequested: function onSuggestionsClearRequested() {
          return _this3._onSuggestionsClearRequested();
        },
        getSuggestionValue: this._getSuggestionValue,
        renderSuggestion: this._renderSuggestion,
        inputProps: inputProps,
        focusFirstSuggestion: true,
        onSuggestionSelected: function onSuggestionSelected(e, d) {
          return _this3._onSuggestionSelected(e, d);
        }
      });
    }
  }]);

  return EquipmentAutosuggest;
}(_react2.default.Component);

EquipmentAutosuggest.propTypes = Object.assign({}, _react2.default.Component, {
  autosuggestId: _propTypes2.default.string,
  onSelect: _propTypes2.default.func.isRequired
});

exports.default = EquipmentAutosuggest;