'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FeedbackButton = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _request = require('../../utils/request');

var _request2 = _interopRequireDefault(_request);

var _PackageInformation = require('../../PackageInformation');

var _PackageInformation2 = _interopRequireDefault(_PackageInformation);

var _reactstrap = require('reactstrap');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FeedbackButton = exports.FeedbackButton = function (_React$Component) {
  _inherits(FeedbackButton, _React$Component);

  function FeedbackButton(props) {
    _classCallCheck(this, FeedbackButton);

    var _this = _possibleConstructorReturn(this, (FeedbackButton.__proto__ || Object.getPrototypeOf(FeedbackButton)).call(this, props));

    _this.state = { sending: false };
    return _this;
  }

  _createClass(FeedbackButton, [{
    key: '_onSendFeedback',
    value: function _onSendFeedback() {
      var _this2 = this;

      this.setState({ sending: true });
      return (0, _request2.default)(this.props.hubUrl + '/feedback', {
        method: 'POST',
        body: JSON.stringify({
          user: this.props.user,
          type: this.refs.lstFeedbackType.value,
          description: this.refs.txtDescription.value,
          packageId: _PackageInformation2.default.packageId,
          packageVersion: _PackageInformation2.default.version,
          packageCommit: _PackageInformation2.default.commit
        })
      }).then(function () {
        _this2.setState({ show: false, sending: false });
      });
    }
  }, {
    key: '_onHide',
    value: function _onHide() {
      this.setState({ show: false, sending: false });
    }
  }, {
    key: '_showPrompt',
    value: function _showPrompt() {
      this.setState({ show: true });
    }
  }, {
    key: 'renderBody',
    value: function renderBody() {
      return _react2.default.createElement(
        'form',
        { className: 'form-horizontal' },
        _react2.default.createElement(
          'div',
          { className: 'form-group' },
          _react2.default.createElement(
            'label',
            { className: 'col-sm-2 control-label' },
            'Type'
          ),
          _react2.default.createElement(
            'div',
            { className: 'col-sm-10' },
            _react2.default.createElement(
              'select',
              { className: 'form-control', ref: 'lstFeedbackType' },
              _react2.default.createElement(
                'option',
                { value: 'bug' },
                'Bug'
              ),
              _react2.default.createElement(
                'option',
                { value: 'feature' },
                'Feature Request'
              ),
              _react2.default.createElement(
                'option',
                { value: 'visual' },
                'Visual Change'
              )
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'form-group' },
          _react2.default.createElement(
            'label',
            { className: 'col-sm-2 control-label' },
            'Description'
          ),
          _react2.default.createElement(
            'div',
            { className: 'col-sm-10' },
            _react2.default.createElement('textarea', { className: 'form-control', rows: '3', ref: 'txtDescription' })
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'form-group' },
          _react2.default.createElement(
            'label',
            { className: 'col-sm-2 control-label' },
            'Package'
          ),
          _react2.default.createElement(
            'div',
            { className: 'col-sm-10' },
            _react2.default.createElement(
              'p',
              { className: 'form-control-static' },
              _PackageInformation2.default.name,
              ' (',
              _PackageInformation2.default.packageId,
              ')'
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'form-group' },
          _react2.default.createElement(
            'label',
            { className: 'col-sm-2 control-label' },
            'Version'
          ),
          _react2.default.createElement(
            'div',
            { className: 'col-sm-10' },
            _react2.default.createElement(
              'p',
              { className: 'form-control-static' },
              _PackageInformation2.default.version,
              ' (',
              _PackageInformation2.default.commit,
              ')'
            ),
            _PackageInformation2.default.coreVersion && _react2.default.createElement(
              'p',
              { className: 'form-control-static' },
              'Core: ',
              _PackageInformation2.default.coreVersion
            ),
            _PackageInformation2.default.clientVersion && _react2.default.createElement(
              'p',
              { className: 'form-control-static' },
              'Client: ',
              _PackageInformation2.default.clientVersion
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var btnClasses = (0, _classnames2.default)('btn btn-link', this.props.className, {
        'btn-sm': this.props.size === 'sm',
        'btn-lg': this.props.size === 'lg',
        'btn-xs': this.props.size === 'xs'
      });

      var sendIcon = this.state.sending ? 'fa fa-fw fa-circle-o-notch fa-spin' : 'fa fa-fw fa-send';

      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(
          'button',
          {
            id: 'feedback-button',
            style: this.props.style,
            className: btnClasses,
            title: 'Send Feedback',
            onClick: function onClick() {
              return _this3._showPrompt();
            } },
          _react2.default.createElement('i', { className: 'fa fa-fw ' + (this.props.icon || 'fa-question-circle') }),
          _react2.default.createElement(
            'span',
            { className: 'd-md-none ml-1' },
            'Feedback'
          )
        ),
        _react2.default.createElement(
          _reactstrap.Modal,
          { zIndex: this.props.zIndex, isOpen: this.state.show, toggle: function toggle() {
              return _this3._onHide();
            } },
          _react2.default.createElement(
            _reactstrap.ModalHeader,
            { closeButton: true },
            'Send Feedback'
          ),
          _react2.default.createElement(
            _reactstrap.ModalBody,
            null,
            this.renderBody()
          ),
          _react2.default.createElement(
            _reactstrap.ModalFooter,
            null,
            _react2.default.createElement(
              'button',
              { className: 'btn btn-link text-default', onClick: function onClick() {
                  return _this3._onHide();
                } },
              _react2.default.createElement('i', { className: 'fa fa-times', 'aria-hidden': 'true' }),
              ' Cancel'
            ),
            _react2.default.createElement(
              'button',
              {
                type: 'button',
                disabled: this.state.sending,
                className: 'btn btn-success',
                onClick: function onClick() {
                  return _this3._onSendFeedback();
                } },
              _react2.default.createElement('i', { className: sendIcon, 'aria-hidden': 'true' }),
              ' ',
              this.state.sending ? 'Sending...' : 'Send'
            )
          )
        )
      );
    }
  }]);

  return FeedbackButton;
}(_react2.default.Component);

FeedbackButton.propTypes = Object.assign({}, _react2.default.Component.propTypes, {
  user: _propTypes2.default.object.isRequired,
  icon: _propTypes2.default.string,
  hubUrl: _propTypes2.default.string.isRequired,
  zIndex: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])
});

FeedbackButton.defaultProps = {
  zIndex: 1050
};

exports.default = FeedbackButton;