'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _upload = require('../../utils/upload');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FileUploader = function (_React$Component) {
  _inherits(FileUploader, _React$Component);

  function FileUploader(props) {
    _classCallCheck(this, FileUploader);

    var _this = _possibleConstructorReturn(this, (FileUploader.__proto__ || Object.getPrototypeOf(FileUploader)).call(this, props));

    _this.currentIndex = 0;
    return _this;
  }

  _createClass(FileUploader, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        {
          style: this.props.style,
          className: this.props.className,
          onDragOver: function onDragOver(e) {
            return _this2._onDragOver(e);
          },
          onDragEnd: function onDragEnd(e) {
            return _this2._onDragEnd(e);
          },
          onDragEnter: function onDragEnter(e) {
            return _this2._onDragEnter(e);
          },
          onDrop: function onDrop(e) {
            return _this2._onDrop(e);
          } },
        this.props.children || 'Drop attachments here'
      );
    }
  }, {
    key: '_onDragOver',
    value: function _onDragOver(e) {
      e = e || event;
      if (e.preventDefault) {
        e.preventDefault(); // Necessary. Allows us to drop.
      }
      if (e.stopPropagation) {
        e.stopPropagation(); // stops the browser from redirecting.
      }
      try {
        e.dataTransfer.dropEffect = this.props.dropEffect || 'copy';
      } catch (err) {}
      return false;
    }
  }, {
    key: '_onDragEnter',
    value: function _onDragEnter(e) {
      e = e || event;
      if (e.preventDefault) {
        e.preventDefault(); // Necessary. Allows us to drop.
      }
      if (e.stopPropagation) {
        e.stopPropagation(); // stops the browser from redirecting.
      }
      return false;
    }
  }, {
    key: '_onDragEnd',
    value: function _onDragEnd(e) {
      e = e || event;
      if (e.preventDefault) {
        e.preventDefault(); // Necessary. Allows us to drop.
      }
      if (e.stopPropagation) {
        e.stopPropagation(); // stops the browser from redirecting.
      }
      return false;
    }
  }, {
    key: '_onDrop',
    value: function _onDrop(e) {
      e = e || event;
      if (e.stopPropagation) {
        e.stopPropagation(); // stops the browser from redirecting.
      }
      if (e.preventDefault) {
        e.preventDefault(); // Necessary. Allows us to drop.
      }
      this.uploadFiles(e.dataTransfer.files);
    }
  }, {
    key: 'uploadFile',
    value: function uploadFile(file) {
      this.uploadFiles([file]);
    }
  }, {
    key: 'uploadFiles',
    value: function uploadFiles(files) {
      for (var i = 0; i < files.length; i++) {
        (0, _upload.upload)(this.props.uploadUrl, this.props.accessToken, files[i], this.currentIndex, this.props.onProgress || function (ev) {});
        this.currentIndex++;
      }
    }
  }]);

  return FileUploader;
}(_react2.default.Component);

exports.default = FileUploader;


FileUploader.propTypes = {
  children: _propTypes2.default.any,
  dropEffect: _propTypes2.default.string,
  style: _propTypes2.default.object,
  className: _propTypes2.default.string,
  accessToken: _propTypes2.default.string.isRequired,
  uploadUrl: _propTypes2.default.string.isRequired,
  onProgress: _propTypes2.default.func
};