'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormGroup = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var FormGroup = function FormGroup(props) {
  var validationMessageBlock = null;

  var hasError = props.validationMessage && props.validationMessage.length > 0;

  var classes = (0, _classnames2.default)({
    'form-group': true,
    'form-group-sm': true,
    'has-error': hasError
  });

  if (hasError) {
    var messageProps = props.messageProps || {};

    var className = messageProps.className,
        helpBlockProps = _objectWithoutProperties(messageProps, ['className']);

    var messageClassNames = (0, _classnames2.default)('help-block', className);
    validationMessageBlock = _react2.default.createElement(
      'div',
      _extends({ className: messageClassNames }, helpBlockProps),
      props.validationMessage
    );
  }

  return _react2.default.createElement(
    'div',
    { className: classes },
    props.children,
    validationMessageBlock
  );
};

exports.FormGroup = FormGroup;
FormGroup.propTypes = Object.assign({}, _react2.default.Component.propTypes, {
  messageProps: _propTypes2.default.object,
  validationMessage: _propTypes2.default.string
});

exports.default = FormGroup;