'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _BaseComponent2 = require('../BaseComponent');

var _BaseComponent3 = _interopRequireDefault(_BaseComponent2);

var _FeedbackButton = require('../FeedbackButton');

var _FeedbackButton2 = _interopRequireDefault(_FeedbackButton);

var _ReleaseNotesButton = require('../ReleaseNotesButton');

var _ReleaseNotesButton2 = _interopRequireDefault(_ReleaseNotesButton);

var _PackagesDropdown = require('../PackagesDropdown');

var _PackagesDropdown2 = _interopRequireDefault(_PackagesDropdown);

var _PackageInformation = require('../../PackageInformation');

var _PackageInformation2 = _interopRequireDefault(_PackageInformation);

var _LoggedInUser = require('../LoggedInUser');

var _LoggedInUser2 = _interopRequireDefault(_LoggedInUser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = function (_BaseComponent) {
  _inherits(Header, _BaseComponent);

  function Header(props) {
    _classCallCheck(this, Header);

    var _this = _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).call(this, props));

    _get(Header.prototype.__proto__ || Object.getPrototypeOf(Header.prototype), 'bindFunctions', _this).call(_this);
    return _this;
  }

  _createClass(Header, [{
    key: 'renderMenuItemChildren',
    value: function renderMenuItemChildren(parentText, children) {
      var linkChildren = children.map(function (link, li) {
        var badge = link.badgeCount > 0 ? _react2.default.createElement(
          'span',
          { className: 'badge ' + link.badgeClass },
          link.badgeCount
        ) : null;

        return _react2.default.createElement(
          _reactRouter.Link,
          {
            key: link.text,
            to: link.url,
            role: 'user',
            label: link.text,
            className: 'dropdown-item nav-link' },
          _react2.default.createElement(
            'li',
            { key: 'menu-' + parentText + '-' + li + '-' + link.text },
            _react2.default.createElement('i', { className: link.faIcon }),
            ' ',
            link.text,
            ' ',
            badge
          )
        );
      });

      return _react2.default.createElement(
        'ul',
        {
          style: { backgroundColor: this.props.backgroundColor, borderColor: 'transparent' },
          className: 'dropdown-menu',
          'aria-labelledby': parentText + 'Dropdown' },
        linkChildren
      );
    }
  }, {
    key: 'renderMenuItems',
    value: function renderMenuItems() {
      var _this2 = this;

      if (this.props.menuItems) {
        var linkElements = this.props.menuItems.map(function (link, lIndex) {
          if (link.children && link.children.length > 0) {
            var badge = link.badgeCount > 0 ? _react2.default.createElement(
              'span',
              { className: 'badge ' + link.badgeClass },
              link.badgeCount
            ) : null;

            return _react2.default.createElement(
              'li',
              { key: 'menu-' + link.text + '-' + lIndex, className: 'nav-item dropdown' },
              _react2.default.createElement(
                'a',
                {
                  className: 'nav-link dropdown-toggle',
                  href: '#',
                  id: link.text + 'Dropdown',
                  'data-toggle': 'dropdown',
                  'aria-haspopup': 'true',
                  'aria-expanded': 'false' },
                _react2.default.createElement('i', { className: link.faIcon }),
                ' ',
                link.text,
                ' ',
                badge
              ),
              _this2.renderMenuItemChildren(link.text, link.children)
            );
          } else {
            var _badge = link.badgeCount > 0 ? _react2.default.createElement(
              'span',
              { className: 'badge ' + link.badgeClass },
              link.badgeCount
            ) : null;

            return _react2.default.createElement(
              _reactRouter.Link,
              { key: link.text, to: link.url, className: 'nav-item nav-link', label: link.text },
              _react2.default.createElement(
                'li',
                { key: 'menu-' + link.text + '-' + lIndex },
                _react2.default.createElement('i', { className: link.faIcon, 'aria-hidden': 'true' }),
                ' ',
                link.text,
                ' ',
                _badge
              )
            );
          }
        });

        return _react2.default.createElement(
          'ul',
          { className: 'nav navbar-nav' },
          linkElements
        );
      } else {
        return _react2.default.createElement('ul', { className: 'nav navbar-nav' });
      }
    }
  }, {
    key: 'renderActionIcons',
    value: function renderActionIcons() {
      // this could eventually render an array of buttons
      return _react2.default.createElement(
        'li',
        { className: 'my-auto' },
        this.props.actionIcons
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var navBarStyle = {
        backgroundColor: this.props.backgroundColor || _PackageInformation2.default.color || 'black',
        color: this.props.foregroundColor || 'white'
      };

      return _react2.default.createElement(
        'nav',
        { className: 'navbar navbar-expand-md navbar-dark', style: navBarStyle },
        _react2.default.createElement(_PackagesDropdown2.default, null),
        _react2.default.createElement(
          'button',
          {
            className: 'navbar-toggler navbar-toggler-right',
            type: 'button',
            'data-toggle': 'collapse',
            'data-target': '#header-menu',
            'aria-controls': 'header-menu',
            'aria-expanded': 'false',
            'aria-label': 'Toggle navigation' },
          _react2.default.createElement('span', { className: 'navbar-toggler-icon' })
        ),
        _react2.default.createElement(
          'div',
          {
            id: 'header-menu',
            className: 'collapse navbar-collapse',
            style: { backgroundColor: this.props.backgroundColor } },
          this.renderMenuItems(),
          _react2.default.createElement(
            'div',
            { style: { flex: 1 } },
            _react2.default.createElement(
              'ul',
              { className: 'navbar-nav justify-content-end' },
              this.renderActionIcons(),
              _react2.default.createElement(
                'li',
                { className: 'my-auto d-md-none d-lg-block' },
                _react2.default.createElement(_ReleaseNotesButton2.default, {
                  packageName: _PackageInformation2.default.name,
                  packageCommit: _PackageInformation2.default.commit,
                  packageVersion: _PackageInformation2.default.version,
                  buttonClassName: 'nav-link',
                  packageBuildTime: _PackageInformation2.default.buildTime,
                  releaseNotes: _PackageInformation2.default.releaseNotes || {}
                })
              ),
              _react2.default.createElement(
                'li',
                { className: 'my-auto d-md-none d-lg-block' },
                _react2.default.createElement(_FeedbackButton2.default, {
                  hubUrl: window.__HUB_URL__,
                  icon: 'fa-smile-o',
                  className: 'nav-link',
                  user: this.props.user
                })
              ),
              _react2.default.createElement(_LoggedInUser2.default, {
                user: this.props.user,
                profileDropdownItems: this.props.profileDropdownItems,
                flushNotificationQueue: this.props.flushNotificationQueue,
                isFlushingNotificationQueue: this.props.isFlushingNotificationQueue
              })
            )
          )
        )
      );
    }
  }]);

  return Header;
}(_BaseComponent3.default);

Header.propTypes = {};

exports.default = Header;