'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoggedInUser = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _BaseComponent2 = require('../BaseComponent');

var _BaseComponent3 = _interopRequireDefault(_BaseComponent2);

var _LoggedInUser = require('../../styles/LoggedInUser.css');

var _LoggedInUser2 = _interopRequireDefault(_LoggedInUser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LoggedInUser = exports.LoggedInUser = function (_BaseComponent) {
  _inherits(LoggedInUser, _BaseComponent);

  function LoggedInUser(props) {
    _classCallCheck(this, LoggedInUser);

    var _this = _possibleConstructorReturn(this, (LoggedInUser.__proto__ || Object.getPrototypeOf(LoggedInUser)).call(this, props));

    _get(LoggedInUser.prototype.__proto__ || Object.getPrototypeOf(LoggedInUser.prototype), 'bindFunctions', _this).call(_this);
    return _this;
  }

  _createClass(LoggedInUser, [{
    key: '_hasProfileImage',
    value: function _hasProfileImage() {
      return !!this.props.user.profileImageUrl;
    }
  }, {
    key: '_onLogout',
    value: function _onLogout() {
      this.props.logout();
    }
  }, {
    key: '_renderProfileImage',
    value: function _renderProfileImage() {
      if (this._hasProfileImage()) {
        return _react2.default.createElement('img', {
          className: 'img-circle',
          style: { borderRadius: '50%' },
          height: 24,
          width: 24,
          src: this.props.user.profileImageUrl
        });
      } else {
        return _react2.default.createElement(
          'span',
          { className: _LoggedInUser2.default.profileIcon },
          _react2.default.createElement('strong', { className: 'fa fa-fw fa-user-circle' })
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      if (!this.props.user) {
        return null;
      }

      var anchorClasses = (0, _classnames2.default)('nav-link dropdown-toggle', _defineProperty({}, _LoggedInUser2.default.profileImage, this._hasProfileImage()));
      var profileItems = this.props.profileDropdownItems ? this.props.profileDropdownItems() : undefined;

      return _react2.default.createElement(
        'li',
        { className: 'nav-item dropdown' },
        _react2.default.createElement(
          'a',
          {
            href: '#',
            className: anchorClasses,
            'data-toggle': 'dropdown',
            role: 'button',
            'aria-haspopup': 'true',
            'aria-expanded': 'false' },
          this._renderProfileImage(),
          ' ',
          this.props.user.displayName,
          ' ',
          _react2.default.createElement('span', { className: 'caret' })
        ),
        _react2.default.createElement(
          'ul',
          { className: 'dropdown-menu', style: this.props.style },
          profileItems,
          profileItems && _react2.default.createElement('div', { className: 'dropdown-divider separator' }),
          _react2.default.createElement(
            'a',
            {
              href: '#',
              className: 'dropdown-item nav-link',
              role: 'button',
              onClick: function onClick() {
                _this2._onLogout();
              } },
            _react2.default.createElement('i', { className: 'fa fas fa-fw fa-sign-out' }),
            ' Logout'
          )
        )
      );
    }
  }]);

  return LoggedInUser;
}(_BaseComponent3.default);

LoggedInUser.propTypes = {
  flushNotificationQueue: _propTypes2.default.func,
  isFlushingNotificationQueue: _propTypes2.default.bool,
  user: _propTypes2.default.object,
  style: _propTypes2.default.object
};

exports.default = LoggedInUser;