'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PermissionCheck = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _request = require('../../utils/request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PermissionCheck = exports.PermissionCheck = function (_React$Component) {
  _inherits(PermissionCheck, _React$Component);

  function PermissionCheck(props) {
    _classCallCheck(this, PermissionCheck);

    var _this = _possibleConstructorReturn(this, (PermissionCheck.__proto__ || Object.getPrototypeOf(PermissionCheck)).call(this, props));

    _this.state = {
      permissionChecked: false,
      permissionGranted: false,
      nodeId: props.nodeId
    };
    return _this;
  }

  _createClass(PermissionCheck, [{
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.state.nodeId !== nextProps.nodeId) {
        this.checkPermissions(nextProps.nodeId);
      }
    }
  }, {
    key: 'checkPermissions',
    value: function checkPermissions(nodeId) {
      var _this2 = this;

      this.setState({
        nodeId: nodeId,
        permissionChecked: false,
        permissionGranted: false
      });
      var url = '/api/user/hasPermission/';
      if (this.props.permission) {
        url += this.props.permission + '/';
      }
      if (nodeId) {
        url += nodeId + '/';
      }

      return (0, _request2.default)(url, { method: 'GET' }).then(function (response) {
        _this2.setState({ permissionChecked: true, permissionGranted: response, nodeId: nodeId });
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.checkPermissions(this.props.nodeId);
    }
  }, {
    key: 'render',
    value: function render() {
      if (!this.state.permissionChecked || !this.state.permissionGranted) {
        return _react2.default.createElement('span', null);
      } else {
        return this.props.children;
      }
    }
  }]);

  return PermissionCheck;
}(_react2.default.Component);

PermissionCheck.propTypes = Object.assign({}, _react2.default.Component.propTypes, {
  permission: _propTypes2.default.string,
  nodeId: _propTypes2.default.string,
  children: _propTypes2.default.any
});

exports.default = PermissionCheck;