'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PersonCard = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _BaseComponent2 = require('../BaseComponent');

var _BaseComponent3 = _interopRequireDefault(_BaseComponent2);

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _DisplayName = require('../DisplayName');

var _DisplayName2 = _interopRequireDefault(_DisplayName);

var _NodePath = require('../NodePath');

var _NodePath2 = _interopRequireDefault(_NodePath);

var _UserProfileImage = require('../UserProfileImage');

var _UserProfileImage2 = _interopRequireDefault(_UserProfileImage);

require('../../styles/PersonCard.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PersonCard = exports.PersonCard = function (_BaseComponent) {
  _inherits(PersonCard, _BaseComponent);

  function PersonCard(props) {
    _classCallCheck(this, PersonCard);

    var _this = _possibleConstructorReturn(this, (PersonCard.__proto__ || Object.getPrototypeOf(PersonCard)).call(this, props));

    _this.bindFunctions();
    return _this;
  }

  _createClass(PersonCard, [{
    key: '_renderPersonHeader',
    value: function _renderPersonHeader() {
      var subtitleClasses = (0, _classnames2.default)('ims-card__subtitle ims-person-card__subtitle', {
        'ims-person-card__subtitle--double': this.props.showHireDate || this.props.showPositionStartDate
      });

      var hireDate = this.props.showHireDate && this.props.person.hireDate ? _react2.default.createElement(
        'span',
        null,
        'Hired ',
        (0, _moment2.default)(this.props.person.hireDate).format('M/D/YYYY')
      ) : null;

      var positionDate = this.props.showPositionStartDate && this.props.person.showPositionStartDate ? _react2.default.createElement(
        'span',
        null,
        'Position ',
        (0, _moment2.default)(this.props.person.positionStartDate).format('M/D/YYYY')
      ) : null;

      return _react2.default.createElement(
        'div',
        { className: 'ims-person-card__header-container' },
        _react2.default.createElement(
          'div',
          { className: 'ims-person-card__header-left-container' },
          _react2.default.createElement(_UserProfileImage2.default, { src: this.props.person.profileImageUrl })
        ),
        _react2.default.createElement(
          'div',
          { className: 'ims-person-card__header-right-container' },
          _react2.default.createElement(
            'div',
            { className: 'ims-card__title' },
            _react2.default.createElement(_DisplayName2.default, { user: this.props.person })
          ),
          _react2.default.createElement(
            'div',
            { className: subtitleClasses },
            _react2.default.createElement(
              'div',
              {
                className: 'ims-person-card__text-ellipsis',
                title: this.props.person.positionPath },
              _react2.default.createElement(_NodePath2.default, { path: this.props.person.positionPath, removeFirst: true })
            ),
            _react2.default.createElement(
              'div',
              null,
              hireDate,
              ' ',
              positionDate
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_Card2.default, _extends({ style: this.props.style, renderHeader: this._renderPersonHeader }, this.props));
    }
  }]);

  return PersonCard;
}(_BaseComponent3.default);

PersonCard.propTypes = Object.assign({}, _react2.default.Component.propTypes, {
  person: _propTypes2.default.shape({
    firstName: _propTypes2.default.string.isRequired,
    lastName: _propTypes2.default.string.isRequired,
    displayName: _propTypes2.default.string,
    positionPath: _propTypes2.default.string,
    hireDate: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.instanceOf(_moment2.default), _propTypes2.default.object]),
    positionStartDate: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.instanceOf(_moment2.default), _propTypes2.default.object])
  }).isRequired,
  showHireDate: _propTypes2.default.bool,
  showPositionStartDate: _propTypes2.default.bool
});

exports.default = PersonCard;