'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReleaseNotesButton = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _showdown = require('showdown');

var _showdown2 = _interopRequireDefault(_showdown);

var _localStorage = require('../../utils/localStorage');

var _PackageInformation = require('../../PackageInformation');

var _PackageInformation2 = _interopRequireDefault(_PackageInformation);

require('../../styles/animate.min.css');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RELEASE_NOTES_STORAGE_KEY = 'RELEASE_NOTES_LAST_VERSION';

// This is probably not the best approach, there are several listed here:
// http://stackoverflow.com/questions/1043339/javascript-for-detecting-browser-language-preference
// The best is probably sending a cookie with the user's preferred language

var language = window.navigator.userLanguage || window.navigator.language;
var converter = new _showdown2.default.Converter();

var ReleaseNotesButton = exports.ReleaseNotesButton = function (_React$Component) {
  _inherits(ReleaseNotesButton, _React$Component);

  function ReleaseNotesButton(props) {
    _classCallCheck(this, ReleaseNotesButton);

    var _this = _possibleConstructorReturn(this, (ReleaseNotesButton.__proto__ || Object.getPrototypeOf(ReleaseNotesButton)).call(this, props));

    _this.state = { show: false, isNew: false };
    _this.compareVersion();
    return _this;
  }

  _createClass(ReleaseNotesButton, [{
    key: 'compareVersion',
    value: function compareVersion() {
      var _this2 = this;

      (0, _localStorage.getItem)(RELEASE_NOTES_STORAGE_KEY).then(function (lastVersion) {
        if (!lastVersion || lastVersion !== _PackageInformation2.default.buildTime) {
          _this2.setState({ isNew: true });
        }
      });
    }
  }, {
    key: '_onHide',
    value: function _onHide() {
      this.setState({ show: false, sending: false });
    }
  }, {
    key: '_showPrompt',
    value: function _showPrompt() {
      this.setState({ show: true, isNew: false });
      (0, _localStorage.setItem)(RELEASE_NOTES_STORAGE_KEY, _PackageInformation2.default.buildTime);
    }
  }, {
    key: 'getReleaseLocale',
    value: function getReleaseLocale(release) {
      if (release && release.notes) {
        var releaseLocale = void 0;
        release.notes.forEach(function (rl) {
          if (rl.locale === language) {
            releaseLocale = rl;
          }
        });
        if (!releaseLocale) {
          releaseLocale = release.notes[0];
        }
        return releaseLocale;
      }
      if (release && release.locales) {
        // new style from Parcel
        var l = release.locales.find(function (l) {
          return l.locale === language;
        });
        if (l) {
          return l;
        } else {
          return release.locales[0];
        }
      } else {
        return undefined;
      }
    }
  }, {
    key: 'getIcon',
    value: function getIcon(item) {
      if (this.props.getIcon) {
        return this.props.getIcon(item);
      }
      var iconClass = void 0;
      for (var i = 0; i < item.tags.length; i++) {
        var t = item.tags[i];

        switch (t) {
          case 'feature':
            iconClass = 'fa fa-fw fa-star text-success';
            break;
          case 'bug-fix':
            iconClass = 'fa fa-fw fa-bug text-danger';
            break;
          case 'miscellaneous':
            iconClass = 'fa fa-fw fa-check-circle-o text-warning';
            break;
        }
      }
      iconClass = iconClass || 'fa fa-fw fa-circle-o';
      return _react2.default.createElement('i', { className: iconClass });
    }
  }, {
    key: 'renderRelease',
    value: function renderRelease(release) {
      var _this3 = this;

      if (this.props.renderRelease) {
        return this.props.renderRelease(release);
      }

      var releaseLocale = this.getReleaseLocale(release);
      if (releaseLocale) {
        var notes = releaseLocale.items || releaseLocale.notes || [];
        var key = release.major + '-' + release.minor + '-' + release.patch;
        return _react2.default.createElement(
          'div',
          { key: key },
          this.renderReleaseHeader(release),
          _react2.default.createElement(
            'table',
            { className: 'table table-condensed table-sm' },
            _react2.default.createElement(
              'tbody',
              null,
              notes.map(function (i, index) {
                return _this3.renderItem(i, index, key);
              })
            )
          )
        );
      } else {
        return _react2.default.createElement(
          'div',
          { key: 'no-release-info' },
          _react2.default.createElement(
            'h4',
            null,
            'No release information available'
          )
        );
      }
    }
  }, {
    key: 'renderReleaseHeader',
    value: function renderReleaseHeader(release) {
      if (this.props.renderReleaseHeader) {
        return this.props.renderReleaseHeader(release);
      }
      var releaseLocale = this.getReleaseLocale(release);
      if (releaseLocale.header) {
        if (releaseLocale.header.indexOf(release.version) === -1) {
          releaseLocale.header = release.version + ' - ' + releaseLocale.header;
        }
        return _react2.default.createElement(
          'h4',
          null,
          _react2.default.createElement('span', { dangerouslySetInnerHTML: { __html: converter.makeHtml(releaseLocale.header) } }),
          ' '
        );
      } else {
        return _react2.default.createElement(
          'h4',
          null,
          release.version
        );
      }
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item, index, key) {
      if (this.props.renderItem) {
        return this.props.renderItem(item, index, key);
      }
      var icon = this.getIcon(item);

      return _react2.default.createElement(
        'tr',
        { key: 'release-note-' + index + '-' + key, style: { verticalAlign: 'top' } },
        _react2.default.createElement(
          'td',
          { style: { verticalAlign: 'top', paddingRight: '5px', width: '30px' } },
          icon
        ),
        _react2.default.createElement(
          'td',
          { style: { verticalAlign: 'top' } },
          _react2.default.createElement('span', { dangerouslySetInnerHTML: { __html: converter.makeHtml(item.description) } })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var animatedProperty = 'animated ' + this.props.newAnimationEffect;
      var btnClasses = (0, _classnames2.default)('btn btn-link', this.props.buttonClassName, {
        'btn-sm': this.props.size === 'sm',
        'btn-lg': this.props.size === 'lg',
        'btn-xs': this.props.size === 'xs'
      });

      var iconClasses = (0, _classnames2.default)('fa fa-fw', this.props.buttonIcon, _defineProperty({}, animatedProperty, this.state.isNew));

      // Old PackageInformations contained a single release
      // This should wrap old releases as an array so everything continues working

      var releasesContent = void 0;
      if (_PackageInformation2.default.releaseNotes && typeof _PackageInformation2.default.releaseNotes === 'string') {
        releasesContent = _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: _PackageInformation2.default.releaseNotes } });
      } else {
        var releases = _PackageInformation2.default.releaseNotes instanceof Array ? _PackageInformation2.default.releaseNotes : [_PackageInformation2.default.releaseNotes];
        releasesContent = releases.map(function (rn) {
          return _this4.renderRelease(rn);
        });
      }
      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(
          'button',
          {
            id: 'whats-new-button',
            style: this.props.buttonStyle,
            className: btnClasses,
            title: this.props.buttonTitle,
            onClick: function onClick() {
              return _this4._showPrompt();
            } },
          _react2.default.createElement('i', { className: iconClasses }),
          ' ',
          _react2.default.createElement(
            'span',
            { className: 'd-md-none' },
            'What\'s New?'
          ),
          _react2.default.createElement(
            _reactstrap.Modal,
            { zIndex: this.props.zIndex, isOpen: this.state.show, toggle: function toggle() {
                return _this4._onHide();
              } },
            _react2.default.createElement(
              _reactstrap.ModalHeader,
              null,
              this.props.modalTitle || 'What\'s New in ' + _PackageInformation2.default.name
            ),
            _react2.default.createElement(
              _reactstrap.ModalBody,
              null,
              _react2.default.createElement(
                'div',
                { style: { maxHeight: '600px', overflowY: 'auto' } },
                releasesContent
              )
            ),
            _react2.default.createElement(
              _reactstrap.ModalFooter,
              null,
              _react2.default.createElement(
                'button',
                { className: 'btn btn-secondary', onClick: function onClick() {
                    return _this4._onHide();
                  } },
                _react2.default.createElement('i', { className: 'fa fa-times', 'aria-hidden': 'true' }),
                ' Close'
              )
            )
          )
        )
      );
    }
  }]);

  return ReleaseNotesButton;
}(_react2.default.Component);

ReleaseNotesButton.propTypes = Object.assign({}, _react2.default.Component.propTypes, {
  buttonClassName: _propTypes2.default.string,
  buttonIcon: _propTypes2.default.string,
  size: _propTypes2.default.string,
  buttonTitle: _propTypes2.default.string,
  modalTitle: _propTypes2.default.string,
  buttonStyle: _propTypes2.default.object,
  getIcon: _propTypes2.default.func,
  renderRelease: _propTypes2.default.func,
  renderReleaseHeader: _propTypes2.default.func,
  renderItem: _propTypes2.default.func,
  getReleaseLocale: _propTypes2.default.func,
  newAnimationEffect: _propTypes2.default.string,
  zIndex: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])
});

ReleaseNotesButton.defaultProps = {
  buttonIcon: 'fa-gift',
  newAnimationEffect: 'infinite rubberBand',
  buttonTitle: 'What\'s New?',
  zIndex: 1050
};

exports.default = ReleaseNotesButton;