'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reselect = require('reselect');

var _imsSharedCore = require('ims-shared-core');

var _PackageInformation = require('../../PackageInformation');

var _PackageInformation2 = _interopRequireDefault(_PackageInformation);

var _auth = require('../../utils/auth');

var _cookies = require('../../utils/cookies');

var _app = require('../../app');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SecureRoute = function () {
  function SecureRoute(store) {
    var notAuthorizedUrl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '/notAuthorized';

    _classCallCheck(this, SecureRoute);

    this.store = store;
    this.notAuthorizedUrl = notAuthorizedUrl;
    this.permHandler = new _imsSharedCore.PermissionHandler({
      package: {
        id: _PackageInformation2.default.packageId
      }
    });
  }

  _createClass(SecureRoute, [{
    key: 'onEnter',
    value: function onEnter(nextState, replace, callback) {
      var context = (0, _reselect.createStructuredSelector)({
        route: (0, _app.selectLocationState)(),
        currentUser: (0, _app.selectCurrentUser)()
      })(this.store.getState());

      var rt = (0, _cookies.getCookie)(_imsSharedCore.Constants.Cookies.RefreshToken);

      if (!context.currentUser.userAccountId || !rt) {
        // Use window.location here to force the request to go to the server. The server
        // handles "/users/authorize" will check windows and other auth before redirecting
        // to the local login page.
        var authorizeUrl = (0, _auth.getAuthorizeUrl)(context.route.locationBeforeTransitions.pathname);
        window.location = authorizeUrl;
        return;
      }

      if (_lodash2.default.isArray(this.requiredPermissions) && this.requiredPermissions.length > 0) {
        if (!this.permHandler.checkPermissions(this.requiredPermissions, context.currentUser.permissions)) {
          replace(this.notAuthorizedUrl);
        }
      } else {
        var requiredPermission = {
          role: this.authorize || 'user',
          action: this.permission || '*'
        };

        if (!this.permHandler.checkPermission(requiredPermission, context.currentUser.permissions)) {
          replace(this.notAuthorizedUrl);
        }
      }

      return callback();
    }
  }]);

  return SecureRoute;
}();

exports.default = SecureRoute;