'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SingleUserSelector = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _DisplayName = require('../DisplayName');

var _DisplayName2 = _interopRequireDefault(_DisplayName);

var _UserAutosuggest = require('../UserAutosuggest');

var _UserAutosuggest2 = _interopRequireDefault(_UserAutosuggest);

require('../../styles/SingleUserSelector.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SingleUserSelector = exports.SingleUserSelector = function (_React$Component) {
  _inherits(SingleUserSelector, _React$Component);

  function SingleUserSelector(props) {
    _classCallCheck(this, SingleUserSelector);

    var _this = _possibleConstructorReturn(this, (SingleUserSelector.__proto__ || Object.getPrototypeOf(SingleUserSelector)).call(this, props));

    _this.state = {
      selectMode: false
    };
    return _this;
  }

  _createClass(SingleUserSelector, [{
    key: '_onCancel',
    value: function _onCancel() {
      this.setState({
        selectMode: false
      });
    }
  }, {
    key: '_onSelect',
    value: function _onSelect(suggestion) {
      this.props.onChange(suggestion);
      this.setState({
        selectMode: false
      });
    }
  }, {
    key: '_onShowSelectMode',
    value: function _onShowSelectMode() {
      this.setState({
        selectMode: true
      });
    }
  }, {
    key: '_renderDisplayMode',
    value: function _renderDisplayMode() {
      var _this2 = this;

      if (this.props.renderSelectedUser) {
        return this.props.renderSelectedUser();
      } else {
        var buttonClasses = (0, _classnames2.default)('btn btn-link', {
          'btn-sm': this.props.size === 'sm',
          'btn-lg': this.props.size === 'lg',
          'btn-xs': this.props.size === 'xs'
        });
        var clearButtonClasses = (0, _classnames2.default)(buttonClasses, 'text-danger');

        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_DisplayName2.default, { className: 'ims-single-user-selector__display-name', user: this.props.value }),
          _react2.default.createElement(
            'button',
            { className: buttonClasses, onClick: function onClick() {
                return _this2._onShowSelectMode();
              } },
            _react2.default.createElement('i', { className: 'fa fa-fw fa-user' }),
            ' ',
            this.props.label || 'Choose Employee'
          ),
          this.props.clearButton && this.props.value && _react2.default.createElement(
            'button',
            { className: clearButtonClasses, onClick: function onClick() {
                return _this2.props.onChange(undefined);
              } },
            _react2.default.createElement('i', { className: 'fa fa-fw fa-times' }),
            ' Clear'
          )
        );
      }
    }
  }, {
    key: '_renderSelectMode',
    value: function _renderSelectMode() {
      var _this3 = this;

      var buttonClasses = (0, _classnames2.default)('btn btn-link', {
        'btn-sm': this.props.size === 'sm',
        'btn-lg': this.props.size === 'lg',
        'btn-xs': this.props.size === 'xs'
      });

      var inputProps = Object.assign({}, { autoFocus: true }, this.props.inputProps);

      return _react2.default.createElement(
        'div',
        { className: 'ims-single-user-selector__select-container' },
        _react2.default.createElement(
          'div',
          { className: 'ims-single-user-selector__select-container-input' },
          _react2.default.createElement(_UserAutosuggest2.default, {
            autosuggestId: this.props.autosuggestId,
            onSelect: function onSelect(s) {
              return _this3._onSelect(s);
            },
            inputProps: inputProps,
            placeholder: this.props.placeholder
          })
        ),
        _react2.default.createElement(
          'div',
          { className: 'ims-single-user-selector__select-container-cancel' },
          _react2.default.createElement(
            'button',
            { className: buttonClasses, onClick: function onClick() {
                return _this3._onCancel();
              } },
            'Cancel'
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.state.selectMode === true) {
        return this._renderSelectMode();
      } else {
        return this._renderDisplayMode();
      }
    }
  }]);

  return SingleUserSelector;
}(_react2.default.Component);

SingleUserSelector.propTypes = {
  autosuggestId: _propTypes2.default.string,
  clearButton: _propTypes2.default.bool,
  inputProps: _propTypes2.default.object,
  label: _propTypes2.default.string,
  renderSelectedUser: _propTypes2.default.func,
  onChange: _propTypes2.default.func.isRequired,
  placeholder: _propTypes2.default.string,
  size: _propTypes2.default.oneOf(['sm', 'md', 'lg', 'xs']),
  value: _propTypes2.default.shape({
    userAccountId: _propTypes2.default.number.isRequired,
    firstName: _propTypes2.default.string.isRequired,
    lastName: _propTypes2.default.string.isRequired,
    displayName: _propTypes2.default.string
  })
};

exports.default = SingleUserSelector;