'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SortableListHeader = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('../../styles/SortableListHeader.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SortableListHeader = exports.SortableListHeader = function (_React$Component) {
  _inherits(SortableListHeader, _React$Component);

  function SortableListHeader(props) {
    _classCallCheck(this, SortableListHeader);

    var _this = _possibleConstructorReturn(this, (SortableListHeader.__proto__ || Object.getPrototypeOf(SortableListHeader)).call(this, props));

    _this._onSortChange = _this._onSortChange.bind(_this);
    return _this;
  }

  _createClass(SortableListHeader, [{
    key: '_onSortChange',
    value: function _onSortChange() {
      if (this.props.sortKey === this.props.sort.key) {
        var reverse = !this.props.sort.reverse;
        this.props.onSortChange(this.props.sortKey, reverse);
      } else {
        this.props.onSortChange(this.props.sortKey, false);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var sortIndicator = null;

      if (this.props.sortKey === this.props.sort.key) {
        var sortClasses = (0, _classnames2.default)({
          fa: true,
          'fa-caret-up': this.props.sort.reverse,
          'fa-caret-down': !this.props.sort.reverse
        });
        sortIndicator = _react2.default.createElement('i', { className: sortClasses });
      }

      return _react2.default.createElement(
        'div',
        { className: 'ims-sortable-header' },
        _react2.default.createElement(
          'a',
          { onClick: this._onSortChange },
          this.props.children,
          ' ',
          sortIndicator
        )
      );
    }
  }]);

  return SortableListHeader;
}(_react2.default.Component);

SortableListHeader.propTypes = Object.assign({}, _react2.default.Component.propTypes, {
  sortKey: _propTypes2.default.string.isRequired,
  sort: _propTypes2.default.shape({
    key: _propTypes2.default.string.isRequired,
    reverse: _propTypes2.default.bool.isRequired
  }),
  onSortChange: _propTypes2.default.func.isRequired
});

exports.default = SortableListHeader;