'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPopper = require('react-popper');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _BaseComponent2 = require('../BaseComponent');

var _BaseComponent3 = _interopRequireDefault(_BaseComponent2);

var _TooltipEditorContainer = require('./TooltipEditorContainer');

var _TooltipEditorContainer2 = _interopRequireDefault(_TooltipEditorContainer);

var _TooltipViewer = require('./TooltipViewer');

var _TooltipViewer2 = _interopRequireDefault(_TooltipViewer);

require('../../styles/Tooltip.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tooltip = function (_BaseComponent) {
  _inherits(Tooltip, _BaseComponent);

  function Tooltip(props) {
    _classCallCheck(this, Tooltip);

    var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call(this, props));

    _this.state = { show: false };
    _this.bindFunctions();
    return _this;
  }

  _createClass(Tooltip, [{
    key: '_onEdit',
    value: function _onEdit(tooltip) {
      this.props.beginEdit(tooltip);
    }
  }, {
    key: '_onMouseEnter',
    value: function _onMouseEnter() {
      if (this.hideTimeout) {
        clearTimeout(this.hideTimeout);
        this.hideTimeout = undefined;
      }
      this.showTimeout = setTimeout(this._showPopup, 500);
    }
  }, {
    key: '_onMouseLeave',
    value: function _onMouseLeave() {
      if (this.showTimeout) {
        clearTimeout(this.showTimeout);
        this.showTimeout = undefined;
      }
      this.hideTimeout = setTimeout(this._hidePopup, 1000);
    }
  }, {
    key: '_showPopup',
    value: function _showPopup() {
      this.showTimeout = undefined;
      this.setState({ show: true });
    }
  }, {
    key: '_hidePopup',
    value: function _hidePopup() {
      this.hideTimeout = undefined;
      if (this.props.isEditing !== true) {
        this.setState({ show: false });
      }
    }
  }, {
    key: '_togglePopup',
    value: function _togglePopup() {
      if (this.state.show === true) {
        this._hidePopup();
      } else {
        this._showPopup();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var canEdit = this.checkPermission('admin:edit-tooltips');

      if (this.props.tooltip.content || this.props.tooltip.link || canEdit === true) {
        var iconClasses = (0, _classnames2.default)('fa fa-info-circle fa-fw', {
          'text-muted': !this.props.tooltip.content && !this.props.tooltip.link
        });

        return _react2.default.createElement(
          _reactPopper.Manager,
          { className: 'ims-tooltip-container' },
          _react2.default.createElement(
            _reactPopper.Target,
            null,
            _react2.default.createElement('span', {
              className: iconClasses,
              onClick: this._togglePopup,
              onMouseEnter: this._onMouseEnter,
              onMouseLeave: this._onMouseLeave
            })
          ),
          this.renderPopup(canEdit)
        );
      } else {
        return null;
      }
    }
  }, {
    key: 'renderPopup',
    value: function renderPopup(canEdit) {
      if (!this.state.show) {
        return null;
      }

      var popperClasses = (0, _classnames2.default)('ims-tooltip clearfix', {
        editing: canEdit && this.props.isEditing
      });

      return _react2.default.createElement(
        _reactPopper.Popper,
        {
          placement: 'top',
          className: popperClasses,
          onMouseEnter: this._onMouseEnter,
          onMouseLeave: this._onMouseLeave },
        _react2.default.createElement(_reactPopper.Arrow, { className: 'ims-tooltip-arrow' }),
        this.renderPopupContent(canEdit)
      );
    }
  }, {
    key: 'renderPopupContent',
    value: function renderPopupContent(canEdit) {
      if (canEdit === true && this.props.isEditing === true) {
        return _react2.default.createElement(_TooltipEditorContainer2.default, { tooltipId: this.props.id });
      } else {
        return _react2.default.createElement(_TooltipViewer2.default, { canEdit: canEdit, onEdit: this._onEdit, tooltip: this.props.tooltip });
      }
    }
  }]);

  return Tooltip;
}(_BaseComponent3.default);

exports.default = Tooltip;


Tooltip.propTypes = {
  beginEdit: _propTypes2.default.func.isRequired,
  cancelEdit: _propTypes2.default.func.isRequired,
  id: _propTypes2.default.string.isRequired,
  isEditing: _propTypes2.default.bool.isRequired,
  tooltip: _propTypes2.default.shape({
    packageTooltipId: _propTypes2.default.number,
    packageId: _propTypes2.default.string.isRequired,
    tooltipId: _propTypes2.default.string.isRequired,
    content: _propTypes2.default.string,
    link: _propTypes2.default.string
  }).isRequired,
  user: _propTypes2.default.object
};