'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactRedux = require('react-redux');

var _reselect = require('reselect');

var _security = require('../../app/modules/security');

var _tooltips = require('../../app/modules/tooltips');

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state, ownProps) {
  return (0, _reselect.createStructuredSelector)({
    isEditing: (0, _tooltips.selectIsEditing)(ownProps.id),
    tooltip: (0, _tooltips.selectTooltip)(ownProps.id),
    user: (0, _security.selectCurrentUser)()
  })(state);
};

var mapDispatchToProps = {
  beginEdit: _tooltips.beginEdit,
  cancelEdit: _tooltips.cancelEdit
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_Tooltip2.default);