'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormGroup = require('../FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _TooltipViewer = require('./TooltipViewer');

var _TooltipViewer2 = _interopRequireDefault(_TooltipViewer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TooltipEditor = function (_React$Component) {
  _inherits(TooltipEditor, _React$Component);

  function TooltipEditor(props) {
    _classCallCheck(this, TooltipEditor);

    var _this = _possibleConstructorReturn(this, (TooltipEditor.__proto__ || Object.getPrototypeOf(TooltipEditor)).call(this, props));

    _this.state = {
      tab: 'edit'
    };
    return _this;
  }

  _createClass(TooltipEditor, [{
    key: '_setTab',
    value: function _setTab(tab) {
      this.setState({ tab: tab });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var navButtonDefaultClasses = 'ims-tab';
      var editNavClasses = (0, _classnames2.default)(navButtonDefaultClasses, {
        selected: this.state.tab === 'edit'
      });
      var previewNavClasses = (0, _classnames2.default)(navButtonDefaultClasses, {
        selected: this.state.tab === 'preview'
      });
      return _react2.default.createElement(
        'div',
        { className: 'ims-tooltip-editor' },
        _react2.default.createElement(
          'nav',
          { className: 'ims-tab-nav' },
          _react2.default.createElement(
            'a',
            {
              role: 'button',
              className: editNavClasses,
              onClick: function onClick() {
                _this2._setTab('edit');
              } },
            'Edit'
          ),
          _react2.default.createElement(
            'a',
            {
              role: 'button',
              className: previewNavClasses,
              onClick: function onClick() {
                _this2._setTab('preview');
              } },
            'Preview'
          )
        ),
        _react2.default.createElement(
          'section',
          null,
          this.state.tab === 'edit' && this.renderEdit(),
          this.state.tab === 'preview' && this.renderPreview()
        ),
        _react2.default.createElement(
          'footer',
          null,
          _react2.default.createElement(
            'button',
            {
              className: 'btn btn-sm btn-link',
              onClick: function onClick() {
                _this2.props.cancelEdit(_this2.props.tooltipId);
              } },
            'Cancel'
          ),
          _react2.default.createElement(
            'button',
            {
              className: 'btn btn-sm btn-primary',
              disabled: this.props.isSaving,
              onClick: function onClick() {
                return _this2.props.saveTooltip(_this2.props.tooltip);
              } },
            'Save'
          )
        )
      );
    }
  }, {
    key: 'renderEdit',
    value: function renderEdit() {
      var _this3 = this;

      return _react2.default.createElement(
        'div',
        { className: 'ims-tooltip-edit-page' },
        _react2.default.createElement(
          _FormGroup2.default,
          null,
          _react2.default.createElement(
            'label',
            { htmlFor: 'content', className: 'control-label' },
            'Content'
          ),
          _react2.default.createElement('textarea', {
            name: 'content',
            className: 'form-control',
            rows: 4,
            value: this.props.tooltip.content || '',
            onChange: function onChange(e) {
              _this3.props.changeContent(_this3.props.tooltipId, e.target.value);
            }
          })
        ),
        _react2.default.createElement(
          _FormGroup2.default,
          null,
          _react2.default.createElement(
            'label',
            { htmlFor: 'link', className: 'control-label' },
            'Link'
          ),
          _react2.default.createElement('input', {
            type: 'url',
            name: 'link',
            className: 'form-control',
            value: this.props.tooltip.link || '',
            onChange: function onChange(e) {
              _this3.props.changeLink(_this3.props.tooltipId, e.target.value);
            }
          })
        )
      );
    }
  }, {
    key: 'renderPreview',
    value: function renderPreview() {
      return _react2.default.createElement(
        'div',
        { className: 'ims-tooltip-edit-preview-page' },
        _react2.default.createElement(_TooltipViewer2.default, { tooltip: this.props.tooltip })
      );
    }
  }]);

  return TooltipEditor;
}(_react2.default.Component);

exports.default = TooltipEditor;


TooltipEditor.propTypes = {
  cancelEdit: _propTypes2.default.func.isRequired,
  changeContent: _propTypes2.default.func.isRequired,
  changeLink: _propTypes2.default.func.isRequired,
  isSaving: _propTypes2.default.bool.isRequired,
  saveTooltip: _propTypes2.default.func.isRequired,
  tooltipId: _propTypes2.default.string.isRequired,
  tooltip: _propTypes2.default.shape({
    packageTooltipId: _propTypes2.default.number,
    packageId: _propTypes2.default.string.isRequired,
    tooltipId: _propTypes2.default.string.isRequired,
    content: _propTypes2.default.string,
    link: _propTypes2.default.string
  }).isRequired
};