'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactRedux = require('react-redux');

var _reselect = require('reselect');

var _tooltips = require('../../app/modules/tooltips');

var _TooltipEditor = require('./TooltipEditor');

var _TooltipEditor2 = _interopRequireDefault(_TooltipEditor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state, ownProps) {
  return (0, _reselect.createStructuredSelector)({
    isSaving: (0, _tooltips.selectIsSaving)(ownProps.tooltipId),
    tooltip: (0, _tooltips.selectEditTooltip)(ownProps.tooltipId)
  })(state);
};

var mapDispatchToProps = {
  cancelEdit: _tooltips.cancelEdit,
  changeContent: _tooltips.changeContent,
  changeLink: _tooltips.changeLink,
  saveTooltip: _tooltips.saveTooltip
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_TooltipEditor2.default);