'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UserAutosuggest = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAutosuggest = require('react-autosuggest');

var _reactAutosuggest2 = _interopRequireDefault(_reactAutosuggest);

var _request = require('../../utils/request');

var _request2 = _interopRequireDefault(_request);

var _cookies = require('../../utils/cookies');

var _UserAutosuggestItem = require('./UserAutosuggestItem');

var _UserAutosuggestItem2 = _interopRequireDefault(_UserAutosuggestItem);

require('../../styles/Autosuggest.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UserAutosuggest = exports.UserAutosuggest = function (_React$Component) {
  _inherits(UserAutosuggest, _React$Component);

  function UserAutosuggest(props) {
    _classCallCheck(this, UserAutosuggest);

    var _this = _possibleConstructorReturn(this, (UserAutosuggest.__proto__ || Object.getPrototypeOf(UserAutosuggest)).call(this, props));

    _this.state = {
      value: '',
      users: [],
      isLoading: false
    };
    _this.lastRequestId = null;
    return _this;
  }

  _createClass(UserAutosuggest, [{
    key: '_getSuggestionValue',
    value: function _getSuggestionValue(suggestion) {
      return suggestion.displayName ? suggestion.displayName : suggestion.firstName + ' ' + suggestion.lastName;
    }
  }, {
    key: '_renderSuggestion',
    value: function _renderSuggestion(suggestion) {
      return _react2.default.createElement(_UserAutosuggestItem2.default, { user: suggestion });
    }
  }, {
    key: '_loadUsers',
    value: function _loadUsers(search) {
      var _this2 = this;

      // Cancel the previous request
      if (this.lastRequestId !== null) {
        clearTimeout(this.lastRequestId);
      }

      this.setState({
        isLoading: true
      });

      var postBody = {
        filter: search
      };

      if (Array.isArray(this.props.includeNodes) && this.props.includeNodes.length > 0) {
        postBody.ancestors = {
          include: this.props.includeNodes
        };
      } else if (typeof this.props.includeNodes === 'number' && this.props.includeNodes >= 0) {
        postBody.ancestors = {
          include: [this.props.includeNodes]
        };
      }

      var requestOptions = {
        method: 'POST',
        body: JSON.stringify(postBody)
      };

      this.lastRequestId = setTimeout(function () {
        (0, _request2.default)((0, _cookies.getHubUrl)() + '/api/userAccounts/search', requestOptions).then(function (result) {
          if (result && result.success === true) {
            if (result.total === 0) {
              // No matching user accounts
              _this2.setState({
                isLoading: false,
                users: []
              });
            } else {
              _this2.setState({
                isLoading: false,
                users: result.userAccounts
              });
            }
          } else {
            // Error result from query
            _this2.setState({
              isLoading: false,
              error: 'User search returned an error: ' + result.message,
              users: null
            });
          }
        }).catch(function (error) {
          // Request error
          _this2.setState({
            isLoading: false,
            error: 'User search failed: ' + error.message,
            users: null
          });
        });
      }, 250);
    }
  }, {
    key: '_onChange',
    value: function _onChange(event, _ref) {
      var newValue = _ref.newValue;

      this.setState({
        value: newValue
      });
    }
  }, {
    key: '_onUserChange',
    value: function _onUserChange(value) {
      this.setState({ filter: value });
    }
  }, {
    key: '_onSuggestionsClearRequested',
    value: function _onSuggestionsClearRequested() {
      this.setState({
        users: []
      });
    }
  }, {
    key: '_onSuggestionsFetchRequested',
    value: function _onSuggestionsFetchRequested(_ref2) {
      var value = _ref2.value;

      this._loadUsers(value);
    }
  }, {
    key: '_onSuggestionSelected',
    value: function _onSuggestionSelected(event, _ref3) {
      var suggestion = _ref3.suggestion;

      this.props.onSelect(suggestion);
      this.setState({
        value: ''
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state = this.state,
          value = _state.value,
          users = _state.users;

      var inputProps = _extends({
        className: 'form-control',
        placeholder: this.props.placeholder || 'To add a person start typing their name...',
        value: value
      }, this.props.inputProps, {
        onChange: function onChange(e, d) {
          return _this3._onChange(e, d);
        }
      });

      return _react2.default.createElement(_reactAutosuggest2.default, {
        id: this.props.autosuggestId,
        suggestions: users,
        onSuggestionsFetchRequested: function onSuggestionsFetchRequested(e) {
          return _this3._onSuggestionsFetchRequested(e);
        },
        onSuggestionsClearRequested: function onSuggestionsClearRequested() {
          return _this3._onSuggestionsClearRequested();
        },
        getSuggestionValue: this._getSuggestionValue,
        renderSuggestion: this._renderSuggestion,
        inputProps: inputProps,
        focusFirstSuggestion: true,
        onSuggestionSelected: function onSuggestionSelected(e, d) {
          return _this3._onSuggestionSelected(e, d);
        }
      });
    }
  }]);

  return UserAutosuggest;
}(_react2.default.Component);

UserAutosuggest.propTypes = Object.assign({}, _react2.default.Component, {
  autosuggestId: _propTypes2.default.string,
  includeNodes: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.arrayOf(_propTypes2.default.number)]),
  onSelect: _propTypes2.default.func.isRequired,
  placeholder: _propTypes2.default.string
});

exports.default = UserAutosuggest;