'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = connectScoped;

var _reactRedux = require('react-redux');

var _redux = require('redux');

var after = function after(fn, _after) {
  return function () {
    var result = fn.apply(this, arguments);
    result = _after.call(this, result);
    return result;
  };
};

function connectScoped(scopeProps) {
  return (0, _reactRedux.connect)(function (state, ownProps) {
    state = state.toJS ? state.toJS() : state;
    if (state[ownProps.scope]) {
      return _extends({}, state[ownProps.scope], ownProps);
    } else {
      return ownProps;
    }
  }, function (dispatch, ownProps) {
    for (var k in scopeProps.actions) {
      scopeProps.actions[k] = after(scopeProps.actions[k], function (res) {
        res['__SCOPE'] = ownProps.scope;
        return res;
      });
    }
    return (0, _redux.bindActionCreators)(scopeProps.actions, dispatch);
  });
}