'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.decodeJWT = decodeJWT;
exports.getAuthorizeUrl = getAuthorizeUrl;

var _PackageInformation = require('../PackageInformation');

var _PackageInformation2 = _interopRequireDefault(_PackageInformation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function decodeJWT(token) {
  try {
    var parts = token.split('.');
    var buffer = Buffer.from(parts[1], 'base64');
    return JSON.parse(buffer.toString('utf8'));
  } catch (e) {
    return null;
  }
}

function getAuthorizeUrl(returnPath) {
  var authorizeUrl = window.__HUB_URL__ + '/users/authorize?packageid=' + encodeURIComponent(_PackageInformation2.default.packageId);
  if (returnPath) {
    authorizeUrl += '&return=' + encodeURIComponent(returnPath);
  }
  if (window.__DEV__) {
    authorizeUrl += '&redirect=' + encodeURIComponent(location.origin);
  }
  return authorizeUrl;
}