'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteCookie = deleteCookie;
exports.deleteSpecificCookie = deleteSpecificCookie;
exports.getCookie = getCookie;
exports.getHubUrl = getHubUrl;

var _imsSharedCore = require('ims-shared-core');

exports.default = {
  deleteCookie: deleteCookie,
  getCookie: getCookie,
  getHubUrl: getHubUrl
};
function deleteCookie(name) {
  document.cookie = name + '=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;';
}

// #TODO
function deleteSpecificCookie(name, domain) {
  document.cookie = name + '=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;domain=' + domain;
}

function getCookie(name) {
  var re = new RegExp(name + '=([^;]+)');
  var value = re.exec(document.cookie);
  return value != null ? unescape(value[1]) : null;
}

function getHubUrl() {
  return getCookie(_imsSharedCore.Constants.Cookies.HubUrl);
}