'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRequestHeader = createRequestHeader;
exports.createAuthenticatedRequestHeader = createAuthenticatedRequestHeader;

var _imsSharedCore = require('ims-shared-core');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createRequestHeader(packageId) {
  return _defineProperty({
    accept: 'application/json',
    'content-type': 'application/json'
  }, _imsSharedCore.Constants.RequestHeaders.PackageId, packageId);
}

function createAuthenticatedRequestHeader(packageId, accessToken) {
  return Object.assign(createRequestHeader(packageId), _defineProperty({}, _imsSharedCore.Constants.RequestHeaders.Authorization, 'JWT ' + accessToken));
}