'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prepareInjector = prepareInjector;
exports.injectScopedReducer = injectScopedReducer;
var storeInstance;
var injectorInstance;

function prepareInjector(store, injector) {
  storeInstance = store;
  injectorInstance = injector;
}

function injectScopedReducer(scope, reducer) {
  var wrappedReducer = wrapReducer(scope, reducer);

  injectorInstance(storeInstance, { key: scope, reducer: wrappedReducer });
}

var wrapReducer = function wrapReducer(scope, reducer) {
  return function (state, action) {
    if (!action['__SCOPE'] || action['__SCOPE'] === scope) {
      return reducer(state, action);
    } else {
      return state;
    }
  };
};