'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getItem = getItem;
exports.getItems = getItems;
exports.setItem = setItem;
exports.setItems = setItems;
exports.removeItem = removeItem;
exports.removeItems = removeItems;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _localforage = require('localforage');

var _localforage2 = _interopRequireDefault(_localforage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

exports.default = {
  getItem: getItem,
  getItems: getItems,
  removeItem: removeItem,
  removeItems: removeItems,
  setItem: setItem,
  setItems: setItems
};
function getItem(key) {
  return _localforage2.default.getItem(key);
}

function getItems(keys) {
  if (!_lodash2.default.isArray(keys) || keys.length === 0) {
    return _bluebird2.default.resolve({});
  }

  var getPromises = keys.map(function (key) {
    return getItem(key).then(function (value) {
      return _defineProperty({}, key, value);
    });
  });

  return _bluebird2.default.all(getPromises).then(function (values) {
    return Object.assign.apply(Object, [{}].concat(_toConsumableArray(values)));
  });
}

function setItem(key, value) {
  return _localforage2.default.setItem(key, value);
}

function setItems(items) {
  if (!_lodash2.default.isObjectLike(items)) {
    throw new TypeError('items should be an object');
  }

  var keys = Object.keys(items);

  if (keys.length === 0) {
    return _bluebird2.default.resolve();
  }

  var setPromises = keys.map(function (key) {
    return setItem(key, items[key]);
  });

  return _bluebird2.default.all(setPromises);
}

function removeItem(key) {
  return _localforage2.default.removeItem(key);
}

function removeItems(keys) {
  if (!_lodash2.default.isArray(keys)) {
    throw new TypeError('keys should be an array');
  }

  if (keys.length === 0) {
    return _bluebird2.default.resolve();
  }

  var removePromises = keys.map(function (key) {
    return removeItem(key);
  });

  return _bluebird2.default.all(removePromises);
}